| 1 | #!/bin/bash -e |
| 2 | # |
| 3 | # OSS-Fuzz build script. See: |
| 4 | # https://google.github.io/oss-fuzz/getting-started/new-project-guide/#buildsh |
| 5 | # |
| 6 | # The file is consumed by: |
| 7 | # https://github.com/google/oss-fuzz/blob/master/projects/qemu/Dockerfiles |
| 8 | # |
| 9 | # This code is licensed under the GPL version 2 or later. See |
| 10 | # the COPYING file in the top-level directory. |
| 11 | # |
| 12 | |
| 13 | # build project |
| 14 | # e.g. |
| 15 | # ./autogen.sh |
| 16 | # ./configure |
| 17 | # make -j$(nproc) all |
| 18 | |
| 19 | # build fuzzers |
| 20 | # e.g. |
| 21 | # $CXX $CXXFLAGS -std=c++11 -Iinclude \ |
| 22 | # /path/to/name_of_fuzzer.cc -o $OUT/name_of_fuzzer \ |
| 23 | # -fsanitize=fuzzer /path/to/library.a |
| 24 | |
| 25 | fatal () { |
| 26 | echo "Error : ${*}, exiting." |
| 27 | exit 1 |
| 28 | } |
| 29 | |
| 30 | OSS_FUZZ_BUILD_DIR="./build-oss-fuzz/" |
| 31 | |
| 32 | # There seems to be a bug in clang-11 (used for builds on oss-fuzz) : |
| 33 | # accel/tcg/cputlb.o: In function `load_memop': |
| 34 | # accel/tcg/cputlb.c:1505: undefined reference to `qemu_build_not_reached' |
| 35 | # |
| 36 | # When building with optimization, the compiler is expected to prove that the |
| 37 | # statement cannot be reached, and remove it. For some reason clang-11 doesn't |
| 38 | # remove it, resulting in an unresolved reference to qemu_build_not_reached |
| 39 | # Undefine the __OPTIMIZE__ macro which compiler.h relies on to choose whether |
| 40 | # to " #define qemu_build_not_reached() g_assert_not_reached() " |
| 41 | EXTRA_CFLAGS="$CFLAGS -U __OPTIMIZE__" |
| 42 | |
| 43 | if ! { [ -e "./COPYING" ] && |
| 44 | [ -e "./MAINTAINERS" ] && |
| 45 | [ -e "./Makefile" ] && |
| 46 | [ -d "./docs" ] && |
| 47 | [ -e "./VERSION" ] && |
| 48 | [ -d "./linux-user" ] && |
| 49 | [ -d "./system" ];} ; then |
| 50 | fatal "Please run the script from the top of the QEMU tree" |
| 51 | fi |
| 52 | |
| 53 | mkdir -p $OSS_FUZZ_BUILD_DIR || fatal "mkdir $OSS_FUZZ_BUILD_DIR failed" |
| 54 | cd $OSS_FUZZ_BUILD_DIR || fatal "cd $OSS_FUZZ_BUILD_DIR failed" |
| 55 | |
| 56 | |
| 57 | if [ -z ${OUT+x} ]; then |
| 58 | DEST_DIR=$(realpath "./DEST_DIR") |
| 59 | else |
| 60 | DEST_DIR=$OUT |
| 61 | fi |
| 62 | |
| 63 | mkdir -p "$DEST_DIR/lib/" # Copy the shared libraries here |
| 64 | |
| 65 | # Build once to get the list of dynamic lib paths, and copy them over |
| 66 | ../configure --disable-werror --cc="$CC" --cxx="$CXX" --enable-fuzzing \ |
| 67 | --prefix="/opt/qemu-oss-fuzz" \ |
| 68 | --extra-cflags="$EXTRA_CFLAGS" --target-list="i386-softmmu" |
| 69 | |
| 70 | if ! make "-j$(nproc)" qemu-fuzz-i386; then |
| 71 | fatal "Build failed. Please specify a compiler with fuzzing support"\ |
| 72 | "using the \$CC and \$CXX environment variables"\ |
| 73 | "\nFor example: CC=clang CXX=clang++ $0" |
| 74 | fi |
| 75 | |
| 76 | if [ "$GITLAB_CI" != "true" ]; then |
| 77 | for i in $(ldd ./qemu-fuzz-i386 | cut -f3 -d' '); do |
| 78 | cp "$i" "$DEST_DIR/lib/" |
| 79 | done |
| 80 | rm qemu-fuzz-i386 |
| 81 | |
| 82 | # Build a second time to build the final binary with correct rpath |
| 83 | ../configure --disable-werror --cc="$CC" --cxx="$CXX" --enable-fuzzing \ |
| 84 | --prefix="/opt/qemu-oss-fuzz" \ |
| 85 | --extra-cflags="$EXTRA_CFLAGS" --extra-ldflags="-Wl,-rpath,\$ORIGIN/lib" \ |
| 86 | --target-list="i386-softmmu" |
| 87 | make "-j$(nproc)" qemu-fuzz-i386 V=1 |
| 88 | fi |
| 89 | |
| 90 | # Place data files in the preinstall tree |
| 91 | make install DESTDIR=$DEST_DIR/qemu-bundle |
| 92 | rm -rf $DEST_DIR/qemu-bundle/opt/qemu-oss-fuzz/bin |
| 93 | rm -rf $DEST_DIR/qemu-bundle/opt/qemu-oss-fuzz/libexec |
| 94 | |
| 95 | export ASAN_OPTIONS=detect_leaks=0 |
| 96 | targets=$(./qemu-fuzz-i386 | grep generic-fuzz | awk '$1 ~ /\*/ {print $2}') |
| 97 | base_copy="$DEST_DIR/qemu-fuzz-i386-target-$(echo "$targets" | head -n 1)" |
| 98 | |
| 99 | cp "./qemu-fuzz-i386" "$base_copy" |
| 100 | |
| 101 | # Run the fuzzer with no arguments, to print the help-string and get the list |
| 102 | # of available fuzz-targets. Copy over the qemu-fuzz-i386, naming it according |
| 103 | # to each available fuzz target (See 05509c8e6d fuzz: select fuzz target using |
| 104 | # executable name) |
| 105 | for target in $(echo "$targets" | tail -n +2); |
| 106 | do |
| 107 | # Ignore the generic-fuzz target, as it requires some environment variables |
| 108 | # to be configured. We have some generic-fuzz-{pc-q35, floppy, ...} targets |
| 109 | # that are thin wrappers around this target that set the required |
| 110 | # environment variables according to predefined configs. |
| 111 | if [[ $target == "generic-fuzz-"* ]]; then |
| 112 | ln $base_copy \ |
| 113 | "$DEST_DIR/qemu-fuzz-i386-target-$target" |
| 114 | fi |
| 115 | done |
| 116 | |
| 117 | echo "Done. The fuzzers are located in $DEST_DIR" |
| 118 | exit 0 |